randomtest 2.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100
  1. #!/bin/sh
  2. # If not specified in environment...
  3. if ! test "$LIBC"; then
  4. # Select which libc to build against
  5. LIBC="glibc"
  6. LIBC="uclibc"
  7. fi
  8. # x86 32-bit:
  9. #CROSS_COMPILER_PREFIX="i486-linux-uclibc-"
  10. # My system has strange prefix for x86 64-bit uclibc:
  11. #CROSS_COMPILER_PREFIX="x86_64-pc-linux-gnu-"
  12. if test $# -lt 2 || ! test -d "$1" || test -e "$2"; then
  13. echo "Usage: $0 SRC_DIR TMP_DIR"
  14. echo
  15. echo "SRC_DIR will be copied to TMP_DIR directory."
  16. echo "Then a random build will be performed."
  17. echo
  18. echo "Useful variables:"
  19. echo "\$LIBC, \$CROSS_COMPILER_PREFIX, \$MAKEOPTS"
  20. exit 1
  21. fi
  22. cp -dpr -- "$1" "$2" || { echo "copy error"; exit 1; }
  23. cd -- "$2" || { echo "cd $dir error"; exit 1; }
  24. # Generate random config
  25. make randconfig >/dev/null || { echo "randconfig error"; exit 1; }
  26. # Tweak resulting config
  27. cat .config \
  28. | grep -v CONFIG_DEBUG_PESSIMIZE \
  29. | grep -v CONFIG_WERROR \
  30. | grep -v CONFIG_CROSS_COMPILER_PREFIX \
  31. | grep -v CONFIG_SELINUX \
  32. | grep -v CONFIG_EFENCE \
  33. | grep -v CONFIG_DMALLOC \
  34. \
  35. | grep -v CONFIG_RFKILL \
  36. >.config.new
  37. mv .config.new .config
  38. echo '# CONFIG_DEBUG_PESSIMIZE is not set' >>.config
  39. echo '# CONFIG_WERROR is not set' >>.config
  40. echo "CONFIG_CROSS_COMPILER_PREFIX=\"${CROSS_COMPILER_PREFIX}\"" >>.config
  41. echo '# CONFIG_SELINUX is not set' >>.config
  42. echo '# CONFIG_EFENCE is not set' >>.config
  43. echo '# CONFIG_DMALLOC is not set' >>.config
  44. echo '# CONFIG_RFKILL is not set' >>.config
  45. # If glibc, don't build static
  46. if test x"$LIBC" = x"glibc"; then
  47. cat .config \
  48. | grep -v CONFIG_STATIC \
  49. >.config.new
  50. mv .config.new .config
  51. echo '# CONFIG_STATIC is not set' >>.config
  52. fi
  53. # If uclibc, build static, and remove some things
  54. # likely to not work on uclibc.
  55. if test x"$LIBC" = x"uclibc"; then
  56. cat .config \
  57. | grep -v CONFIG_STATIC \
  58. | grep -v CONFIG_BUILD_LIBBUSYBOX \
  59. | grep -v CONFIG_PIE \
  60. \
  61. | grep -v CONFIG_FEATURE_2_4_MODULES \
  62. | grep -v CONFIG_FEATURE_SYNC_FANCY \
  63. | grep -v CONFIG_FEATURE_TOUCH_NODEREF \
  64. >.config.new
  65. mv .config.new .config
  66. echo 'CONFIG_STATIC=y' >>.config
  67. echo '# CONFIG_BUILD_LIBBUSYBOX is not set' >>.config
  68. echo '# CONFIG_PIE is not set' >>.config
  69. echo '# CONFIG_FEATURE_2_4_MODULES is not set' >>.config
  70. echo '# CONFIG_FEATURE_SYNC_FANCY is not set' >>.config
  71. echo '# CONFIG_FEATURE_TOUCH_NODEREF is not set' >>.config
  72. fi
  73. # If STATIC, remove some things.
  74. # PAM with static linking is probably pointless
  75. # (but I need to try - now I don't have libpam.a on my system, only libpam.so)
  76. if grep -q "^CONFIG_STATIC=y" .config; then
  77. cat .config \
  78. | grep -v CONFIG_PAM \
  79. >.config.new
  80. mv .config.new .config
  81. echo '# CONFIG_PAM is not set' >>.config
  82. fi
  83. # Regenerate .config with default answers for yanked-off options
  84. # (most of default answers are "no").
  85. { yes "" | make oldconfig >/dev/null; } || { echo "oldconfig error"; exit 1; }
  86. # Build!
  87. nice -n 10 make $MAKEOPTS 2>&1 | tee make.log
  88. # Return exitcode 1 if busybox executable does not exist
  89. test -x busybox